﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;

namespace NMemcached.Client.Test
{
    public static class MemcachedSettings
    {
        public static readonly string[] Servers = new string[] { "127.0.0.1" };

        static MemcachedSettings()
        {
        }

        public static void ErrorHandler(object sender, ConnectionEventArgs e)
        {
            if (e.SocketException != null)
            {
                Console.WriteLine("ERROR: {0}", e.SocketException.Message);
            }
        }

        public static IConnectionProvider CreateConnectionProvider(bool useBinaryProtocol = false, bool useCompression = false)
        {
            ServerConnectionCollection servers = new ServerConnectionCollection();
            IPEndPoint remoteEp = new IPEndPoint(IPAddress.Parse(MemcachedSettings.Servers[0]), 11211);

            ServerConnection localhost = null;
            if (useBinaryProtocol)
            {
                localhost = new BinaryConnection(TransportType.Tcp, remoteEp);
            }
            else
            {
                localhost = new TextConnection(remoteEp);
            }
            localhost.UseCompression = useCompression;
            servers.Add(localhost);

            return new ConnectionProvider(servers);
        }
    }
}
