﻿using System;
using System.Activities;

namespace NMemcached.Client.Activities
{
    /// <summary>
    /// Deletes an item from the cache
    /// </summary>
    public sealed class DeleteActivity : KeyedMemecachedActivity
    {
        /// <summary>
        /// Gets or sets the response code from the delete operation
        /// </summary>
        public OutArgument<ResponseCode> Response { get; set; }

        /// <summary>
        /// Initializes a new instance of the DeleteActivity class
        /// </summary>
        public DeleteActivity()
            : base()
        {
        }

        /// <summary>
        /// Performs the execution of the activity
        /// </summary>
        /// <param name="context">The execution context under which the activity executes</param>
        protected override void Execute(CodeActivityContext context)
        {
            base.Execute(context);
            if (String.IsNullOrWhiteSpace(this.CacheKey))
            {
                throw new ArgumentNullException("Key");
            }
            else
            {
                this.Response.Set(context, this.CacheConnection.Delete(this.CacheKey));
            }
        }
    }
}
