﻿
namespace NMemcached.Client.Activities
{
    /// <summary>
    /// Specifies the storage operations available to the StorageActivity class
    /// </summary>
    public enum StorageAction
    {
        /// <summary>
        /// Adds the item to the cache if it does not alreay exist
        /// </summary>
        Add,
        /// <summary>
        /// Appends the item to an existing entry
        /// </summary>
        Append,
        /// <summary>
        /// Sets the entry to the new value only if it was not updated since the last get operation
        /// </summary>
        CheckAndSet,
        /// <summary>
        /// Prepends the item to an existing entry
        /// </summary>
        Prepend,
        /// <summary>
        /// Replaces an existing entry with a new value
        /// </summary>
        Replace,
        /// <summary>
        /// Sets the entry to the specified value overwriting any existing value
        /// </summary>
        Set
    };
}
