﻿using System;

namespace NMemcached.Client
{
    /// <summary>
    /// Defines values saved with cache entries that require special processing
    /// </summary>
    [Flags]
    internal enum StorageFlags : ushort
    {
        /// <summary>
        /// No special processing
        /// </summary>
        None = 0,
        /// <summary>
        /// Specifies that the content of the entry is serialized
        /// </summary>
        Serialized = 16384,
        /// <summary>
        /// Specifies that the content of the entry is compressed
        /// </summary>
        Compressed = 32768
    };
}
