﻿using System;

namespace NMemcached.Client.Text
{
    /// <summary>
    /// A data structure that contains details from a text response
    /// </summary>
    [Serializable]
    internal class TextGetDetails
    {
        /// <summary>
        /// Gets or sets the key
        /// </summary>
        public string Key { get; set; }

        /// <summary>
        /// Gets or sets the storage flags
        /// </summary>
        public StorageFlags Flags { get; set; }

        /// <summary>
        /// Gets or sets the content size
        /// </summary>
        public int Size { get; set; }

        /// <summary>
        /// Gets or sets the check and set unique value
        /// </summary>
        public ulong CasUnique { get; set; }

        /// <summary>
        /// Initializes a new instance of the TextGetDetails class
        /// </summary>
        public TextGetDetails()
        {
            this.Flags = StorageFlags.None;
        }
    }
}
